diff --git a/configure b/configure
index 1998f7255b9..55ba490b638 100755
--- a/configure
+++ b/configure
@@ -10050,7 +10050,8 @@ for ac_func in \
   openat \
   mkdirat \
   unlinkat \
-  bindat
+  bindat \
+  dladdr
 
 do :
   as_ac_var=`$as_echo "ac_cv_func_$ac_func" | $as_tr_sh`
diff --git a/configure.ac b/configure.ac
index 2f045d91977..8e38f09ef39 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1473,7 +1473,8 @@ AC_CHECK_FUNCS( \
   openat \
   mkdirat \
   unlinkat \
-  bindat
+  bindat \
+  dladdr
 )
 
 AC_TYPE_SIGNAL
diff --git a/src/main/modules.c b/src/main/modules.c
index 09ec073516e..9c28f8751f1 100644
--- a/src/main/modules.c
+++ b/src/main/modules.c
@@ -113,11 +113,15 @@ const section_type_value_t section_type_value[MOD_COUNT] = {
  */
 static int check_module_magic(CONF_SECTION *cs, module_t const *module)
 {
+#ifdef HAVE_DLADDR
 	Dl_info dl_info;
 	dladdr(module, &dl_info);
+#endif
 
 	if (MAGIC_PREFIX(module->magic) != MAGIC_PREFIX(RADIUSD_MAGIC_NUMBER)) {
+#ifdef HAVE_DLADDR
 		cf_log_err_cs(cs, "Failed loading module rlm_%s from file %s", module->name, dl_info.dli_fname);
+#endif
 		cf_log_err_cs(cs, "Application and rlm_%s magic number (prefix) mismatch."
 			      "  application: %x module: %x", module->name,
 			      MAGIC_PREFIX(RADIUSD_MAGIC_NUMBER),
@@ -126,7 +130,9 @@ static int check_module_magic(CONF_SECTION *cs, module_t const *module)
 	}
 
 	if (MAGIC_VERSION(module->magic) != MAGIC_VERSION(RADIUSD_MAGIC_NUMBER)) {
+#ifdef HAVE_DLADDR
 		cf_log_err_cs(cs, "Failed loading module rlm_%s from file %s", module->name, dl_info.dli_fname);
+#endif
 		cf_log_err_cs(cs, "Application and rlm_%s magic number (version) mismatch."
 			      "  application: %lx module: %lx", module->name,
 			      (unsigned long) MAGIC_VERSION(RADIUSD_MAGIC_NUMBER),
@@ -135,7 +141,9 @@ static int check_module_magic(CONF_SECTION *cs, module_t const *module)
 	}
 
 	if (MAGIC_COMMIT(module->magic) != MAGIC_COMMIT(RADIUSD_MAGIC_NUMBER)) {
+#ifdef HAVE_DLADDR
 		cf_log_err_cs(cs, "Failed loading module rlm_%s from file %s", module->name, dl_info.dli_fname);
+#endif
 		cf_log_err_cs(cs, "Application and rlm_%s magic number (commit) mismatch."
 			      "  application: %lx module: %lx", module->name,
 			      (unsigned long) MAGIC_COMMIT(RADIUSD_MAGIC_NUMBER),
